; ********************************************************************************************
; 320 usec Timer Interrupt Handler
; ********************************************************************************************


TIMINT:	PUSH	R16
	PUSH	R22
	PUSH	R23		; Get some work registers
	PUSH	R24
	PUSH	XL
	PUSH	XH
	IN      R24,SREG        ; Save Statusreg
        PUSH    R24
;
; Ab hier alle 320us:
;
TIM500:	ldi	R22,-25		; Set Counter to Startvalue (Divide by 64*25) 
	out	TCNT0,R22
	sei			; Enable next interrupt
	inctim	TIK3U1,3,TIM501	; Increment to 1 ms 
	rcall	DEBNCE		; Debounce Drehgeber alle 1ms
TIM501:	inctim	TIK3U2,25,TIM599 ; Increment to 8 msec
	rcall	DEBNC2		; Debounce Taster
;
; Ab hier alle 8ms:
;
TIM8MS:	inctim	TIK8M,5,TIM502	; Increment to 40 msec	
	rjmp	TIM504		; weiter nach 0ms, 40ms, 80ms ...		
TIM502:	cpi	R24,2
	breq	TIM504		; weiter nach 16ms
TIM599:	rjmp	TIM99		; --> Ende
;
; Ab hier alle 20ms im Abstand: 16ms-24ms-16ms...
;
TIM504:	d2bcd	TIMER+2,0,99	; Decrement Timer ms	
	in	R22,SREG	; Save the Carry Flag
	d2bcd	TIMER+2,0,99
	sbrs	R22,0		; Skip if Carry set (after first Decrement)
	rjmp	TIM101
TIM10:	d2bcd	TIMER,0,99	; Decrement Timer s
TIM101:	lds	R24,TIMER+3	; Wenn Timer 00:00 erreicht hat
	tst	R24
	brne	TIM102		
	lds	R24,TIMER+2
	tst	R24
	brne	TIM102
	lds	R24,TIMER+1
	tst	R24
	brne	TIM103
	lds	R24,TIMER
	tst	R24
	brne	TIM103
	rjmp	TIM104
TIM102:	rjmp	TIM20
TIM103:	rjmp	TIM18
	;
TIM104:	lds	R24,TFOXS	; .. Timer auf Startwert setzen
	sts	TIMER,R24
	lds	R24,TFOXS+1
	sts	TIMER+1,R24
	lds	R24,TFOXS+2
	sts	TIMER+2,R24
	lds	R24,TFOXS+3
	sts	TIMER+3,R24
	;
	lds	R24,FOX		; Wenn derzeitiger Fuchs <> Maxwert
	lds	R23,NFOX
	cp	R23,R24
	brne	TIM11
	lds	R24,FOX+1
	lds	R23,NFOX+1
	cp	R23,R24
	breq	TIM12
TIM11:	i2bcd	FOX,1,16	; Fuchs hochzaehlen
	rjmp	TIM20
TIM12:	stsi	FOX,0		; Sonst Fuchs auf 1 setzen
	stsi	FOX+1,1
	stsi	BATTIM,1	; Check Battery Time Flag setzen	
	;
TIM18:	lds	R22,TALARM	; Get Alarm-Time
	lds	R23,TALARM+1
	add	R22,R23		; Wenn Zeit = 0
	breq	TIM20		; .. nix tun
	lds	R22,TIMER+1	; Sonst Timer mit Alarm vergleichen
	cp	R22,R23
	brne	TIM20
	lds	R23,TALARM
	lds	R22,TIMER
	cp	R22,R23
	brne	TIM20
	stsi	ALATIM,1	; Bei Match: Flag fr Main setzen			
        ;
TIM20:	inctim	TIK100,5,TIM21	; Increment 20 msec Timer up to 5 (100 ms)
	stsi	TICK,1		; *** @ 100ms set Timing Flag for Main
TIM21:	inctim	TIK20M,50,TIM99	; Increment 20 msec Timer up to 50 (1 s)
;	
; Ab hier alle 1s:
;
	lds	R24,STOPWR	; Falls Stopwatch an
	tst	R24
	breq	TIM30
	i2bcd	STOPW+3,0,59	; Uhr hochzhlen Sekunden
	brcc	TIM30		; 
	i2bcd	STOPW+1,0,59	; Minuten
	brcc	TIM30
	lds	R24,STOPW	; Stunde
	inc	R24
	andi	R24,$07		; Bei 8 h wrappen
	sts	STOPW,R24	
	;
TIM30:	inctim	TIK1S,60,TIM99	; Increment 1 sec Timer
	;
	; ++ 1 min Service
	;    Derzeit nichts... 
	;	
        ; ++ Conclusion of Interrupt Service
	;
TIM99:  CLI			; No interrupts during conclusion
	POP     R24             ; Restore Status Reg
        OUT     SREG,R24
	POP	XH
	POP	XL
	POP	R24
	POP	R23
	POP	R22
	POP	R16
        RETI                    ; Interrupt-Handling beendet

