; ********************************************************************************************
; Subroutinen
; ********************************************************************************************


; ********************************************************************************************
; Stopuhr lschen und starten

CLRSTW:	push	R16
	ldi	R16,0		
	sts	STOPWR,R16	; Run-Flag lschen
	sts	STOPW,R16	; Zeit auf 0 setzen
	sts	STOPW+1,R16
	sts	STOPW+2,R16
	sts	STOPW+3,R16
	sts	STOPW+4,R16
	ldi	R16,1		; und Run-Flag setzen
	sts	STOPWR,R16	
	pop	R16
	ret



; ********************************************************************************************
; Timer lschen bei Klick, +/- bei Drck + Dreh

UDCTMR:	sbrc	R17,4		; Wenn Drckerpuls
	rcall	CLRTIM		; .... dann Timer lschen und starten
UDCT2:	andi	R17,$0C		; Switch-Flag Up Oder Down gesetzt?
	breq	UDCT9		; .. dann derzeitige Fuchs# ndern
        push	R16
        ldi	XL,NFOX		; Pointer auf NFox-BCD-String
        clr	XH
        rcall	BCD2B		; Wandelt 2B BCD @ X,X+1 nach Bin in R16
        mov	R18,R16
        ldi	XL,FOX		; Pointer auf Fox-BCD-String
        clr	XH
	cli			; Interrupt aus
        rcall	BCD2B		; Wandelt 2B BCD @ X,X+1 nach Bin in R16
        ldi	XL,1		; Lower Limit
        mov	XH,R18		; Upper Limit
	sbrs	R17,3		; Up-Flag, dann Fox-Nummer erhoehen
	rcall	INCLIM		; Increment R16 within limits in XH,XL
	sbrs	R17,2		; Down-Flag
	rcall	DECLIM		; Decrement R16 within limits in XH,XL
	ldi	XL,FOX		; Pointer auf BCD-String
        clr	XH
        rcall	B2BCD		; Wandelt Bin in R16 in 2B BCD @ X, X+1
        sei			; Interrupts wieder zulassen
	pop	R16
UDCT9:	ret



; *******************************************************************************************
; Fuchs Timer auf Start-Wert setzen

CLRTIM:	push	R16	
	cli			; Interrupt unterdrcken
	lds	R16,TFOXS	; Zeit von TFOX nach TIMER kopieren
	sts	TIMER,R16
	lds	R16,TFOXS+1
	sts	TIMER+1,R16
	lds	R16,TFOXS+2
	sts	TIMER+2,R16
	lds	R16,TFOXS+3
	sts	TIMER+3,R16
	sei			; Interrupt wieder an 	
	stsi	FOX,0		; Fuchszhler auf 1
	stsi	FOX+1,1
	pop	R16
	ret	



; *******************************************************************************************
; Zahl der Fchse (1..10) verndern

UDNF:	sbrs	R17,2		; Up Flag
	rjmp	NF2
	i2bcd	NFOX,1,10
	rjmp	NF8
NF2:	sbrs	R17,3		; Down Flag
	rjmp	NF9	
	d2bcd	NFOX,1,10
NF8:	rcall	CLRTIM		; Nach nderung: Fuchstimer neu starten
	stsi	SUEEP,1		; EEPROM Change Flag setzen	
NF9:	ret



; *******************************************************************************************
; Zahl der Frequenzen (1..6) verndern

UDNFRQ:	lds	R16,NFREQ
	sbrs	R17,2		; Up Flag
	rjmp	NFRQ2		; nein...

; Frequenzanzahl erhhen:

	cpi	r16,6		; Maximum erreicht?
	breq	NFRQ9		; ja, keine Erhhung mehr mglich
	inc	R16
	rjmp	NFRQ8

NFRQ2:	sbrs	R17,3		; Down Flag
	ret			; nein...

; Frequenzanzahl vermindern:
	
	cpi	r16,1		; Mimumum erreicht?
	breq	NFRQ9		; ja, keine Verminderung mehr mglich...
	dec	R16

; Neue Anzahl speichern:

NFRQ8:	sts	NFREQ,R16
	stsi	FRQX,1		; Nach nderung: Frequenz 1 aktivieren
	rcall	GETFRQ		; Neue Frequenz holen
	rcall	CONVF		; ... und in Anzeigewert umrechnen
	rcall	GETPF		; aktuelle Fuchsleistung aus Array holen
	rcall	CONVPF		; ... und in Anzeigewert umrechnen
	stsi	FRQCHG,1	; Frequency Changed Flag setzen (=PLL laden)
	stsi	SUEEP,1		; EEPROM Change Flag setzen	
	stsi	FRQEEP,1		
NFRQ9:	ret



; *******************************************************************************************
; Schwelle des akustischen S-Meters (ACSM) verndern

UDACSM:	lds	R16,ACSMLV
	sbrs	R17,2		; Up Flag
	rjmp	UDASM1		; nein...
	inc	R16
	rjmp	UDASM2

UDASM1:	sbrs	R17,3		; Down Flag
	ret			; nein...
	dec	R16
UDASM2:	andi	R16,$03		; Limit to 0..3
	sts	ACSMLV,R16
	stsi	SUEEP,1		; EEPROM Change Flag setzen	
	ret



; *******************************************************************************************
; EOT Alarm-Zeit (0..30) verndern

UDTA:	push	R16
	lds	R16,TALARM	; Wenn Alarmzeit = 'Au'
	cpi	R16,'A'
	brne	TA1
	stsi	TALARM,0	; .. durch 00 ersetzen	
	stsi	TALARM+1,0
	;
TA1:	sbrs	R17,2		; Up Flag
	rjmp	TA2
	i2bcd	TALARM,0,30
	rjmp	TA3
TA2:	sbrs	R17,3		; Down Flag
	rjmp	TA8	
	d2bcd	TALARM,0,30
TA3:	stsi	SUEEP,1		; EEPROM Change Flag setzen	
	;
TA8:	lds	R16,TALARM	; Wenn Alarmzeit = 00
	tst	R16
	brne 	TA9
	lds	R16,TALARM+1
	tst	R16
	brne	TA9
	stsi	TALARM,'A'	; .. durch 'Au' ersetzen
	stsi	TALARM+1,'u' 
	;
TA9:	pop	R16
	ret



; *******************************************************************************************
; Laufzeit Fuchs Sekunden(1..99) verndern

UDTFS:	sbrs	R17,2		; Up Flag
	rjmp	TFS2
	i2bcd	TFOXS,1,99
	rjmp	TFS8
TFS2:	sbrs	R17,3		; Down Flag
	rjmp	TFS9	
	d2bcd	TFOXS,1,99
TFS8:	rcall	CLRTIM		; Nach nderung: Fuchstimer neu starten
	stsi	SUEEP,1		; EEPROM Change Flag setzen	
TFS9:	ret



; *******************************************************************************************
; Laufzeit Fuchs ms (0,2..98) verndern

UDTFMS:	sbrs	R17,2		; Up Flag
	rjmp	TFM2
	i2bcd	TFOXMS,0,99	
	i2bcd	TFOXMS,0,99
	brcs	TFM1	
	rjmp	TFM8
TFM1:	i2bcd	TFOXS,1,99
	rjmp	TFM8
TFM2:	sbrs	R17,3		; Down Flag
	rjmp	TFM9	
	d2bcd	TFOXMS,0,99
	brcc	TFM3
	d2bcd	TFOXS,1,99
TFM3:	d2bcd	TFOXMS,0,99
TFM8:	rcall	CLRTIM		; Nach nderung: Fuchstimer neu starten
	stsi	SUEEP,1		; EEPROM Change Flag setzen	
TFM9:	ret



; *******************************************************************************************
; Leistung der Fchse verndern

UDPF:	sbrs	R17,4		; Bit 4 = Druckpuls gesetzt?
	rjmp	UDPF0		; nein...

; nchsten Index einstellen:

	push	r17
	rcall	PUTPF		; Aktuelle Leistung erst speichern: (PFOXBN -> PFOX1..6)
	rcall	NEXTI		; Frequenz-Index um 1 erhhen
	rcall	GETPF		; Neue Fuchsleistung auslesen: (PFOX1..6 -> PFOXBN)
	rcall	CONVPF		; Convert Code to Textform
	rcall	GETFRQ		; Frequenz auch holen und Frequenzsymbol erneuern
	rcall	CONVF		; Dezimale Frequenzanzeige bereitstellen
	stsi	FRQCHG,1	; Frequency Changed Flag setzen (=PLL laden)
	pop	r17
	rjmp	TONCHA

UDPF0:	andi	R17,$0F		; Bit 0, 1, 2 oder 3 gesetzt?
	brne	UDPF1		; ja...
	ret			; keine Eingabe aktiv

; Drck-Dreheingabe:

UDPF1:	rcall	GETPF		; aktuelle Fuchsleistung aus Array holen
	rcall	GETFRQ		; Frequenz auch holen und Frequenzsymbol erneuern
	lds	R16,PFOXBN
	sbrs	R17,2		; Up Flag
	rjmp	UDPFA
	inc	R16
	rjmp	UDPFB

UDPFA:	sbrs	R17,3		; Down Flag
	rjmp	UDPF9
	dec	R16
UDPFB:	cpi	R16,16	 	; Limit to 0..15
	brne	UDPFC
	clr	R16
UDPFC:	cpi	R16,-1
	brne	UDPFD
	ldi	R16,15
UDPFD:	sts	PFOXBN,R16
	rcall	CONVPF		; Convert Code to Textform
	rcall	CONVF		; Dezimale Frequenzanzeige bereitstellen
	rcall	PUTPF		; neuen Wert ins Leistungs-Array zurck schreiben
	stsi	SUEEP,1		; EEPROM Change Flag setzen	
	stsi	FRQCHG,1	; Frequency Changed Flag setzen (=PLL laden)
UDPF9:	ret




; *******************************************************************************************
; Fuchsleistung aus Array laden

GETPF:	lds	r16,FRQX	; Index auf aktive Frequenz laden (1-5)
	dec	r16
	ldi	YL,LOW(PFOX1)	; Anfang des Leistungs-Arrays
	clr	YH
	add	YL,r16		; Byte-Pointer erzeugen
	;
	ld	r16,y+		; Leistungs-Array auslesen
	sts	PFOXBN,r16	; ...und als aktuellen Wert speichern
	ret



; *******************************************************************************************
; Fuchsleistung in Array speichern

PUTPF:	lds	r16,FRQX	; Index auf aktive Frequenz laden (1-5)
	dec	r16		; 0..4
	ldi	YL,LOW(PFOX1)	; Anfang des Leistungs-Arrays
	clr	YH
	add	YL,r16		; Wort-Pointer erzeugen
	;
	lds	r16,PFOXBN	; aktuelle Leistung laden
	st	Y+,r16		; ...und in Leistungs-Array zurck speichern
	ret



; *******************************************************************************************
; Textstring fr Fuchsleistung in PFOX stellen 

CONVPF:	push	R16
	clr 	R16		; Erst mal alles auf 0
	sts	PFOX,R16
	sts	PFOX+1,R16
	sts	PFOX+2,R16
	stsi	PFOX+3,'m'
	;
	lds	R16,PFOXBN	; Binaer Code fr Leistung
CPF0:	cpi	R16,0
	brne	CPF1
	stsi	PFOX+1,1
	stsi	PFOX+3,$E4	; ''
CPF1:	cpi	R16,1
	brne	CPF2
	stsi	PFOX+1,3
	stsi	PFOX+3,$E4	; ''
CPF2:	cpi	R16,2
	brne	CPF3
	stsi	PFOX+0,1
	stsi	PFOX+3,$E4	; ''
CPF3:	cpi	R16,3
	brne	CPF4
	stsi	PFOX+0,3
	stsi	PFOX+3,$E4	; ''
CPF4:	cpi	R16,4
	brne	CPF5
	stsi	PFOX+2,1
CPF5:	cpi	R16,5
	brne	CPF6
	stsi	PFOX+2,3
CPF6:	cpi	R16,6
	brne	CPF7
	stsi	PFOX+1,1
CPF7:	cpi	R16,7
	brne	CPF8
	stsi	PFOX+1,3
CPF8:	cpi	R16,8
	brne	CPF9
	stsi	PFOX+0,1
CPF9:	cpi	R16,9
	brne	CPF10
	stsi	PFOX+0,3
CPF10:	cpi	R16,10
	brne	CPF11
	stsi	PFOX+2,1
	stsi	PFOX+3,' '
CPF11:	cpi	R16,11
	brne	CPF12
	stsi	PFOX+2,3
	stsi	PFOX+3,' '
CPF12:	cpi	R16,12
	brne	CPF13 
	stsi	PFOX+1,1
	stsi	PFOX+3,' '
CPF13:	cpi	R16,13
	brne	CPF14
	stsi	PFOX+1,3
	stsi	PFOX+3,' '
CPF14:	cpi	R16,14
	brne	CPF15
	stsi	PFOX+0,1
	stsi	PFOX+3,' '
CPF15:	cpi	R16,15
	brne	CPF99
	stsi	PFOX+0,3
	stsi	PFOX+3,' '
CPF99:	pop 	R16	
	ret



; *******************************************************************************************	
; Abschwcher-Einstellung verndern

UDABS:	lds	R16,ABSBIN
	sbrc	R17,1		; (Down Flag)
	inc	R16		; ...Dmpfung vermindern
	sbrc	R17,0		; (Up Flag)
	dec	R16		; ...Dmpfung erhhen
	cpi	R16,-1		; Unterlauf?
	brne	UDABS2		; nein...
	ldi	R16,0		; -> auf minimal 0 begrenzen
UDABS2:	cpi	R16,25		; berlauf?
	brne	UDABS3		; nein...
	ldi	R16,24		; -> auf maximal 24 begrenzen
UDABS3:	sts	ABSBIN,R16

; Up & pressed:

	sbrc	R17,2		; Up+Pressed Flag
	rcall	NEXTF		; = nchste Frequenz

; Down & pressed:

	sbrc	R17,3		; Down+Pressed Flag
	rcall	PREVF		; = vorige Frequenz

; Akustisches S-Meter:

	sbrs	R17,4		; Wenn Click Flag gesetzt..
	rjmp	UDABS9
	lds	R16,ACSMON	; .. Akustisches S-Meter Ein/Aus toggeln
	ldi	R18,$40
	eor	R16,R18
	sts	ACSMON,R16
	tst	R16		; Falls neu eingeschaltet ..
	breq	UDABS9	
	ldi	R16,30		; .. dann Nachlaufzeit auf 3 Sekunden
	sts	ACSTIM,R16
UDABS9:	ret



; ********************************************************************************************
; Frequenz erhhen/erniedrigen je nach Flags in R17 (=SWIFLG)

UDFRQ:	sbrc	R17,4		; Bit 4 = Druckpuls gesetzt?
	rjmp	NEXTF		; ja, dann Frequenz um 1 weiterschalten
	andi	R17,$0F		; Bit 0, 1, 2 oder 3 gesetzt?
	brne	UDFRQ1		; ja, Dreheingabe bearbeiten...
	ret

UDFRQ1:	lds	R24,FRQBIN	; Low Byte of Frequency Code
	lds	R25,FRQBIN+1
	;
	sbrc	R17,0		; +/- 10 kHz
	adiw	R24,8
	sbrc	R17,1
	sbiw	R24,8
	sbrc	R17,2		; +/- 1,25 kHz
	adiw	R24,1		
	sbrc	R17,3
	sbiw	R24,1
	;
	tst	R25		; Wenn Ergebnis negativ
	brpl	UDFRQ2		
	clr	R24		; .. auf 0 setzen
	clr	R25
	;
UDFRQ2: lds	R17,FBER68	; Max.-Frq. 146 oder 148?
	tst	R17
	brne	UDFRQ4
	;
	adiw	R24,$20		; Fr 146: Wenn Ergebnis > 1760 = 06E0	
	cpi	R25,$07
	brcs	UDFRQ3
	clr	R24		; .. auf 1760 setzen
	ldi	R25,$07
UDFRQ3:	sbiw	R24,$20
	rjmp	UDFRQ8
	;
UDFRQ4:	sbiw	R24,$20	;	; Fr 148: Wenn Ergebnis > 3360 = 0D20	
	brcs	UDFRQ5		; .. Wenn Ergebnis < 20 nix tun
	cpi	R25,$0D	
	brcs	UDFRQ5
	clr	R24		; .. auf 3360 setzen
	ldi	R25,$0D
UDFRQ5:	adiw	R24,$20
	;
UDFRQ8:	sts	FRQBIN,R24	; Ergebnis abspeichern als Binrwert	
	sts	FRQBIN+1,R25
	rcall	PUTFRQ		; .. und nach FRQ1..6 kopieren
	rcall	CONVF		; Dezimale Frequenzanzeige bereitstellen
	rcall	GETPF		; aktuelle Fuchsleistung aus Array holen
	stsi	FRQEEP,1	; EEPROM Change Flag setzen	
	stsi	FRQCHG,1	; Frequency Changed Flag setzen (=PLL laden)

UDFRQ9:	ret



; ********************************************************************************************
; Frequenz-Index erhhen:

NEXTI:	lds	R16,FRQX	; Frequenz-Index
	lds	R17,NFREQ
	cp	R16,R17
	brne	NEXTI1
	ldi	R16,1		; ...bei > Maximum nach 1 wrappen
	rjmp	NEXTI2

NEXTI1:	inc	R16		; ...erhhen
NEXTI2:	sts	FRQX,R16
	rjmp	SAVFIX		; Neuen Index im EEPROM speichern



; ********************************************************************************************
; Frequenz-Index vermindern:

PREVI:	lds	R16,FRQX	; Frequenz-Index
	dec	R16		; ...vermindern
	brne	PREVI1
	lds	R16,NFREQ	; ...bei 1 nach Maximum wrappen
PREVI1:	sts	FRQX,R16
	rjmp	SAVFIX		; Neuen Index im EEPROM speichern



; *******************************************************************************************
; Vorherigen gespeicherten Kanal einstellen:

PREVF:	push	R17
	rcall 	PUTFRQ		; Aktuelle Frequenz erst speichern: FRQBIN -> FRQ1..6
	rcall	PREVI		; Frequenz-Index um 1 vermindern
	rjmp	NEXTF1



; ********************************************************************************************
; Nchsten gespeicherten Kanal einstellen:

NEXTF:	push	R17
	rcall 	PUTFRQ		; Aktuelle Frequenz erst speichern: FRQBIN -> FRQ1..6
	rcall	NEXTI		; Frequenz-Index um 1 erhhen
NEXTF1:	rcall	GETFRQ		; Get new Frequency FRQ 1..6 -> FRQBIN
	rcall	CONVF		; Dezimale Frequenzanzeige bereitstellen
	rcall	GETPF		; aktuelle Fuchsleistung aus Array holen
	rcall	CONVPF		; Convert Code to Textform
	stsi	FRQCHG,1	; Frequency Changed Flag setzen (=PLL laden)
	flash	STRFRQ,20	; Neue Frequenz String flashen
	pop	r17

; Zu neuem Kanal gehrende Tonfolge ausgeben

TONCHA:	push	r17
	lds 	R16,FRQX	; Zu neuem Kanal gehrende Tonfolge ausgeben
	cpi	R16,1
	brne	TONCH1
	sound	SOUF1		; Neue Frequenz 1 Tonfolge
TONCH1:	cpi	R16,2
	brne	TONCH2
	sound	SOUF2		; Neue Frequenz 2 Tonfolge
TONCH2:	cpi	R16,3
	brne	TONCH3
	sound	SOUF3		; Neue Frequenz 3 Tonfolge
TONCH3:	cpi	R16,4
	brne	TONCH4
	sound	SOUF4		; Neue Frequenz 4 Tonfolge
TONCH4:	cpi	R16,5
	brne	TONCH5
	sound	SOUF5		; Neue Frequenz 5 Tonfolge
TONCH5:	cpi	R16,6
	brne	TONCH6
	sound	SOUF6		; Neue Frequenz 6 Tonfolge
TONCH6:	pop	r17
	ret



; *******************************************************************************************
; Aktuelle Frequenz in FRQBIN -> FRQ1..6 speichern

PUTFRQ:	lds	R16,FRQX	; Index auf aktive Frequenz laden (1-6)
	dec	R16		; 0..5
	ldi	YL,LOW(FRQ1)	; Anfang des Frequenz-Arrays
	clr	YH
	add	YL,R16		; Wort-Pointer
	add	YL,R16		; ...erzeugen
	;
	lds	R16,FRQBIN	; aktuelle Frequenz (H) laden
	st	Y+,R16		; ...und in Frequenz-Array speichern
	lds	R16,FRQBIN+1	; Frequenz (L)
	st	Y,R16		; ...im Array speichern
	;
	ret



; *******************************************************************************************
; Frequenz aus Array holen FRQ1..6 -> FRQBIN

GETFRQ:	lds	R16,FRQX	; Pointer auf aktive Frequenz bauen
	dec	R16		; 0..5
	ldi	YL,LOW(FRQ1)	; Anfang des Frequenz-Arryas	
	clr	YH
	add	YL,R16		; Wort-Pointer
	add	YL,R16		; ...erzeugen

	ld	R16,Y+		; Frequenz (H) laden
	sts	FRQBIN,R16	; ...und aktuell speichern
	ld	R16,Y		; Frequenz (L)
	sts	FRQBIN+1,R16	; ...speichern

; *******************************************************************************************
; Frequenzsymbol erzeugen und speichern

GETFSY:	push	r17
	lds	r16,FRQX	; Frequenz-Index laden	
	cpi	r16,1		; Frequenzsymbol erzeugen
	brne	GETF2
	rcall	F1S		; "I"
GETF2:	cpi	r16,2
	brne	GETF3
	rcall	F2S		; "II"
GETF3:	cpi	r16,3
	brne	GETF4
	rcall	F3S		; "III"
GETF4:	cpi	r16,4
	brne	GETF5
	rcall	F4S		; "IV"
GETF5:	cpi	r16,5
	brne	GETF6
	rcall	F5S		; "V"
GETF6:	cpi	r16,6
	brne	GETF99
	rcall	F6S		; "VI"
GETF99:	ldi	R17,$87		; ASCII-Code des Symbols laden
	sts	FRQXSY,r17
	pop	r17
	ret



; *******************************************************************************************
; Dezimale Frequenzanzeige vorbereiten 2B FRQBIN -> 4B FRQ ****

CONVF:	lds	R24,FRQBIN	; Binres Frequenzcodewort holen
	lds	R25,FRQBIN+1		

; 3 LSB aus Frequenz separieren fr 1 kHz Anzeige

	clc
	clr	R17		; Separierte Bits nach R17
	ror	R25
	ror	R24
	ror	R17
	ror	R25
	ror	R24
	ror	R17
	ror	R25
	ror	R24
	ror	R17
	clc			; Separierte Bits rechtsbndig machen
	ror	R17
	swap	R17
	sbrc	R17,2		; Wenn Wert >= 4
	inc 	R17		; 1 dazu wg 1,25 kHz Abstimmschritt
	sts	FRQ+3,R17	; Unterste Stelle fertig	
				; ...Rest ist im Bereich 0..220
	ldi	R16,3		; 1MHz Startwert
	ldi	R17,9		; 100 kHz
	ldi	R18,0		; 10 kHz

CONVF4:	tst	R24		; Frequenz ist Startwert + Rest * 10 kHz
	breq	CONVF6
CONVF5:	dec	R24
	inc	R18
	cpi	R18,10
	brne	CONVF4
	clr	R18
	inc	R17
	cpi	R17,10
	brne	CONVF4
	clr	R17
	inc	R16
	rjmp	CONVF4

CONVF6:	tst	R25		; Fr grosse F ist bertrag 1 in R25
	breq	CONVF7		
	clr	R25		; .. dann nochmal 256 Increments
	rjmp	CONVF5 

CONVF7:	sts	FRQ,R16
	sts	FRQ+1,R17
	sts	FRQ+2,R18
	ret

; **** PLL-Einstell-Bytes aurechnen und bergeben

SETPLL:	push	R0
	push	R16
	push	R17
	push	R18
	push	R24
	push	R25

	lds	R16,FFINE	; Einstellung fr 143,9 MHz, DB0
	add	R16,R16		;   FFINE * 2 + 1	
	inc	R16
	ldi	R17,$40
	ldi	R18,$27		; .. DB2
	lds	R24,FRQBIN	; Frequenzcode holen
	lds	R25,FRQBIN+1
	clc			; Ein Bit links schieben
	rol	R24
	rol	R25	
	add	R16,R24		; und zum Basiswert addieren
	adc	R17,R25
	rcall	OUTI2C		; Ergebnis an Synthesizer
	;
	pop	R25
	pop	R24
	pop	R18
	pop	R17
	pop	R16
	pop	R0
	ret



; *******************************************************************************************
; UB-Anzeige eichen, dazu UBFINE 0.255 einstellen

CALUB:	push	R16
	push	R17
	lds	R16,UBFINE	; Aktuellen Wert holen
	andi	R17,$0C		; Wenn kein Flag gesetzt
	breq	CALUB3		;  .. nderungsteil berspringen
	;
	sbrc	R17,2		; Increment?
	inc	R16
	sbrc	R17,3		; Decrement?
	dec	R16	
	;
	sts	UBFINE,R16	; Aktuellen Wert speichern
	;
CALUB3:	ldi	XL,UBFVAL	; Aktuellen Wert ...
	clr	XH
	rcall	B3BCD		; .. in 3 BCD in ABSVAL wandeln
        ; 
	pop	R17
	pop	R16
	ret



; *******************************************************************************************
; Frequenznachstimmung eichen

CALFFI:	push	R16
	push	R17
	lds	R16,FFINE	; Aktuellen Wert holen
	andi	R17,$0C		; Wenn kein Flag gesetzt
	breq	CALFF3		;  .. nderungsteil berspringen
	;
	ldi	R18,1
	sts	FRQCHG,R18	; Change Frq Flag setzen	
	;
	sbrc	R17,2		; Increment?
	inc	R16
	sbrc	R17,3		; Decrement?
	dec	R16	
	cpi	R16,90		; Oberes Limit +25 ?
	brne	CALFF1
	ldi	R16,89
CALFF1: cpi	R16,38		; Unteres Limit -25 ?
	brne	CALFF2
	ldi	R16,39	
	;
CALFF2:	sts	FFINE,R16	; Aktuellen Wert speichern
	;
CALFF3:	ldi	R17,64		; Anzeigewert ist FFINE - 64
	sub	R16,R17		; .. = -25 .. +25
	ldi	R17,'+'		; Vorzeichen bestimmen
	sbrc	R16,7
	ldi	R17,'-'
	sts	FFIVAL,R17	; .. und ablegen
	sbrc	R16,7		; Wenn Wert negativ
	neg	R16		; .. komplementieren 
	ldi	XL,FFIVAL+1	; 
	clr	XH
	rcall	B2BCD		; .. in 2 BCD in FFIVAL+1,2 wandeln
        ; 
CALFF9:	pop	R17
	pop	R16
	ret



; *******************************************************************************************
; Abschwcher eichen

CALABS:	push	R16
	push	R17
	ldi	YL,low(ABSTAB)	; Tabelle mit Abschwcherwerten
	ldi	YH,high(ABSTAB)
	;	
	stsi	ABSBIN,0	; Abschwcher auf 0 dB setzen	
	;
CALAB1:	sbic	PIND,6		; Wenn Kippschalter nicht mehr auf Men (FRQ)
	rjmp	CALAB9		; .. abbrechen
	ld	R16,Y		; Aktuellen Wert holen
	lds	R17,SWIFLG	; Switch Flags holen
	clr	R18		; .. und lschen
	sts	SWIFLG,R18
	sbrc	R17,0		; Increment?
	inc	R16
	sbrc	R17,1		; Decrement?
	dec	R16	
	st	Y,R16		; Aktuellen Wert speichern
	;
	sbrs	R17,4		; Click?
	rjmp	CALAB2
	lds	R16,ABSBIN	; Nchste 10 dB-Abschwchereinstellung
	inc	R16
	inc	R16
	cpi	R16,26		; bis maximal 24
	breq	CALAB9
	sts	ABSBIN,R16
	ld	R16,Y+		; Tabellenpointer inkrementieren
	rjmp	CALAB1
	;
CALAB2:	rcall	CONVAB		; Abschwcher einstellen
	ld	R16,Y		; Aktuellen Analogwert
	ldi	XL,ABSVAL	; 
	clr	XH
	rcall	B3BCD		; .. in 3 BCD in ABSVAL wandeln
	rcall	ADUM		; S-Meter-Wert D/A-Wandeln
	rcall	CONVUM		; S-Meter updaten
	show	STRCAL		; Display updaten
	rjmp	CALAB1
	;
CALAB9:	pop	R17
	pop	R16
	ret		
	;
	;
        ; **** Increment R16 within limits in XL,XH
INCLIM:	cp	R16,XH		; Am oberen limit?
	breq	INCL1
	inc	R16		; Nein: inkrementieren
	clc			; und Carry Flag loeschen
	rjmp	INCL9
INCL1:	mov	R16,XL		; Ja: auf unteres Limit setzen
	sec			; Carry Flag setzen
INCL9:	ret	
	;
        ; **** Decrement R16 within limits in XL,XH
DECLIM:	cp	R16,XL		; Am unteren limit?
	breq	DECL1
	dec	R16		; Nein: dekrementieren
	clc			; Und Carry Flag lschen
	rjmp	DECL9
DECL1:	mov	R16,XH		; Ja: auf oberes Limit setzen
	sec			; Und Carry Flag setzen
DECL9:	ret	
	;
	; **** Convert 2B BCD @ X, X+1 nach Bin in R16
BCD2B:	push	R17
	ld	R16,X+		; Get Zehnerstelle
	lsl	R16		; Multiply by 10
	mov	R17,R16	
	lsl	R16	
	lsl	R16
	add	R16,R17
	ld	R17,X		; Get Einerstelle
	add	R16,R17		; And add to result
	dec	XL
	pop	R17	
	ret
	;
	; **** Convert Bin in R16 to 2B BCD @ X, X+1
B2BCD:	push	R16
	push	R17		
	push	R18	
	in      R17,SREG        ; Save Statusreg mit Carry Flag
	push	R17
	;
	clr	R17		; Einerstelle
	clr	R18		; Zehnerstelle
B2B1:	tst	R16		; Bis Bin-Wert auf Null ist
	breq	B2B9
	dec	R16		; Binwert dekrementieren
	inc	R17		; und BCD-Wert inkrementieren
	cpi	R17,10
	brne	B2B1
	clr	R17
	inc	R18
	rjmp	B2B1
B2B9:	st	X+,R18		; Ergebnis ablegen
	st	X,R17
	dec	XL
	;
	pop	R17
	out	SREG,R17	; Carry-Flag wiederherstellen	
	pop	R18
	pop	R17
	pop	R16
	ret	
	;
	; **** Convert Bin in R16 to 3B BCD @ X, X+1, X+2
B3BCD:	push	R16
	push	R17		
	push	R18	
	push	R19
	in      R17,SREG        ; Save Statusreg mit Carry Flag
	push	R17
	;
	clr	R17		; Einerstelle
	clr	R18		; Zehnerstelle
	clr	R19		; Hunderterstelle
B3B1:	tst	R16		; Bis Bin-Wert auf Null ist
	breq	B3B9
	dec	R16		; Binwert dekrementieren
	inc	R17		; und BCD-Wert inkrementieren
	cpi	R17,10
	brne	B3B1
	clr	R17
	inc	R18
	cpi	R18,10
	brne	B3B1
	clr	R18
	inc	R19
	rjmp	B3B1
B3B9:	st	X+,R19		; Ergebnis ablegen
	st	X+,R18
	st	X,R17
	subi	XL,2
	;
	pop	R17
	out	SREG,R17	; Carry-Flag wiederherstellen	
	pop	R19
	pop	R18
	pop	R17
	pop	R16
	ret	



; ********************************************************************************************
; Batterie-Warnungs-Level verndern (von 5,8..8,0 V)

UDUBW:	lds	R16,UBWBIN
	sbrs	R17,2		; Up Flag
	rjmp	UDUBA
	inc	R16
	rjmp	UDUBB
UDUBA:	sbrs	R17,3		; Down Flag
	rjmp	UDUB9
	dec	R16
UDUBB:	cpi	R16,81	 	; Limit to 58..80
	brne	UDUBC
	ldi	R16,80
UDUBC:	cpi	R16,57
	brne	UDUBD
	ldi	R16,58
UDUBD:	sts	UBWBIN,R16
	rcall	CONVBW		; Convert Code to Textform
UDUB9:	ret


; *******************************************************************************************
; Batterie-Warnungs-Level Bin nach Dez wandeln

CONVBW:	lds	R16,UBWBIN	; Binrwert holen
	clr	R17		; Volt-Stelle
	clr	R18		; Zehntel-Volt-Stelle
	;
CVBW1:	tst	R16		; Loopen bis Binrwert auf 0 gezhlt
	breq	CVBW9
	dec	R16		; Binrwert dekrementieren
	inc	R18		; Dezimalwert inkrementieren
	cpi	R18,10		; bertrag handeln
	brne	CVBW1
	clr	R18
	inc	R17
	rjmp	CVBW1
	;
CVBW9:	sts	UBWARN,R17	; Dezimalwert ablegen
	sts	UBWARN+1,R18
	ret	
	


; ********************************************************************************************
; Einen Analogwert Kanal R16 einlesen und in R16 bergeben
;
; 	Scaling Factor in R19,R18 
; 	Benutzt R16 - R22

ANACON:	out     ADMUX,R16	; ADMUX einstellen
	clr	R16		; Wait a little for I/O to settle
AC1:	dec	R16
	brne	AC1
	sbi     ADCSR,6         ; Start ADC
AC2:	sbis	ADCSR,4		; Wait for ADIF 
	rjmp	AC2
	sbi	ADCSR,4		; Clear ADIF
 	in	R16,ADCL	; Get Conversion Results
 	in	R17,ADCH
	rcall	MPY16U
	mov	R16,R20		; 8 bit unsigned result
	tst	R21		; If Result Overflow..
	breq	AC3
	ldi	R16,$FF		; .. Set Result to max
AC3:	ret



;++++  Subroutine for 16x16 Bit Unsigned Multiplication
;
; This subroutine multiplies the two 16-bit register variables 
; Mp16uH:mp16uL and mc16uH:mc16uL.
; The result is placed in m16u3:m16u2:m16u1:m16u0.
;  
; Number of words	:14 + return
; Number of cycles	:153 + return
; Low registers used	:None
; High registers used   :7 R16..R22
;	
;++ Subroutine Register Variables

.def	mc16uL	=r16		;multiplicand low byte
.def	mc16uH	=r17		;multiplicand high byte
.def	mp16uL	=r18		;multiplier low byte
.def	mp16uH	=r19		;multiplier high byte
.def	m16u0	=r18		;result byte 0 (LSB)
.def	m16u1	=r19		;result byte 1
.def	m16u2	=r20		;result byte 2
.def	m16u3	=r21		;result byte 3 (MSB)
.def	mcnt16u	=r22		;loop counter

;++ Code

MPY16u:	clr	m16u3		;clear 2 highest bytes of result
	clr	m16u2
	ldi	mcnt16u,16	;init loop counter
	lsr	mp16uH
	ror	mp16uL
	;
m16u_1:	brcc	noad8		;if bit 0 of multiplier set
	add	m16u2,mc16uL	;add multiplicand Low to byte 2 of res
	adc	m16u3,mc16uH	;add multiplicand high to byte 3 of res
noad8:	ror	m16u3		;shift right result byte 3
	ror	m16u2		;rotate right result byte 2
	ror	m16u1		;rotate result byte 1 and multiplier High
	ror	m16u0		;rotate result byte 0 and multiplier Low
	dec	mcnt16u		;decrement loop counter
	brne	m16u_1		;if not done, loop more
	ret



; *******************************************************************************************
; Messpannung A/D-wandeln und Maximum speichern

ADUM:	ldi	R16,2		; Analog-Channel 2 = UMESS
	ldi	R19,$AB		; Scaling Factor fr S-Meter Empfindlichkeit
	clr	R18		; .. dto., Low Byte
	rcall	ANACON		; A/D-Wandeln, Ergebnis-Bereich 0..255
	sts	UMESSA,R16	; Momentanwert speichern fr akustische Ausgabe
	lds	R17,UMESSP	; Spitzenwert fr Balken-S-Meter bilden 
	cp	R16,R17
	brcs	ADUM8
	sts	UMESSP,R16
	;
ADUM8:	lds	R17,UMESSP 	; Wenn Spitzenwert		
	lds	R18,ACSMLV	; .. grsser/gleich ACSM-Schwellwert
	swap	R18
	cp	R17,R18
	brcs	ADUM9
	ldi	R16,30		; .. dann Nachlaufzeit auf 3 Sekunden
	sts	ACSTIM,R16
	;
ADUM9:	rcall	ACSM		; S-Meter akustisch ausgeben
	ret



; *******************************************************************************************
; Akustisches S-Meter erzeugen 
;
; Eingangswert ist UMESSA 0..255, Bar-S-Meter ab 127 am Anschlag
; Erzeugte Frequenz steigt pro Stufe im Bereich: 
;
; 0..31 um 6/128, 32..63 um 4/128, 64..127 um 2/128, 128..255 um 1/128
;
; Frequenzen sind: 0=100Hz, 32=430Hz, 64=1,2kHz, 128=3,1kHz, 150(Limit)=3,7kHz	  

ACSM:	lds	R16,UMESSA	; Messpannung holen
	cpi	R16,150		; .. und auf 150 begrenzen 
	brcs	ACSM0
	ldi	R16,150
	;
ACSM0:	ldi	R17,$61		; Untere Eckfrequenz 100 Hz, Hi Byte
	ldi	R18,$A8		; dto, Lo Byte
	;
ACSM1:	tst	R16		; Wenn Messwert = 0
	breq	ACSM7		; .. fertig, ausgeben
	;
	dec 	R16		; Sonst Frequenz um 1/128 erhhen
	mov 	R20,R17		; .. = Teilerfaktor 1/128 verringern
	mov	R21,R18
	clr	R19
	rol	R21		; 1 * links schieben
	rol	R20		; .. = 7 * rechts
	rol	R19
	sub	R18,R20
	sbc	R17,R19
	sbrc	R16,7		; Fr die unteren 128 Werte
	rjmp	ACSM1
	sub	R18,R20		; .. nochmal um 1/128 verringern 
	sbc	R17,R19
	sbrc	R16,6		; Fr die untersten 64 Werte
	rjmp	ACSM1
	sub	R18,R20		; .. um nochmal 2/128 verringern 
	sbc	R17,R19
	sub	R18,R20		;  
	sbc	R17,R19
	sbrc	R16,5		; Fr die alleruntersten 32 Werte
	rjmp	ACSM1
	sub	R18,R20		; .. um nochmal 2/128 verringern 
	sbc	R17,R19
	sub	R18,R20		 
	sbc	R17,R19
	rjmp	ACSM1
	;
ACSM7:	lds	R19,SOUPNT+1	; Ist Sound Pointer <> 0 (Sound aktiv)?
	tst	R19
	brne	ACSM9		; .. dann nichts ausgeben
	;
	in	R16,TCNT1L	; Wait until Counter High Byte is 0
	in	R16,TCNT1H	; .. to avoid noise by counter
	tst	R16		; .. counting to max (< 5ms @ 200 Hz)		
	brne	ACSM7
	;
	out	OCR1AH,R17	; Variablen Oscillator laden 
	out	OCR1AL,R18
	;
	lds	R16,ACSMON	; Piepser je nach Flag Ein-/Aus-Schalten
	lds	R17,ACSTIM 	; Wenn Nachlaufzeit > 0	..
	tst	R17
	brne	ACSM8
	clr	R16		; .. dann Piepser auf jeden Fall ausschalten
ACSM8:	out	TCCR1A,R16
	sbrc	R16,6		; NF Degate entsprechend schalten
	sbi	DDRB,2
	sbrs	R16,6
	cbi	DDRB,2
	;
ACSM9:	ret


; ********************************************************************************************
; Soundgenerator (Alle 100 ms aufrufen)
;
; Wenn Soundpointer aktiv: Nchstes Element aus Sound-String holen
; und mit Frequenz 10 kHz/Wert piepsen

SOUGEN:	lds	ZL,SOUPNT	; Sound-Pointer holen
	lds	ZH,SOUPNT+1
	tst	ZH		; Wenn MSB = 0
	breq	SOUG9		; .. dann nichts ausgeben
	lpm			; Get one Byte to R0
	adiw	ZL,1		; Increment Z
	out	OCR1AH,R0	; Variablen Oscillator laden 
 	clr	R18
	out	OCR1AL,R18
	dec	R0		; Sonderfall Wert = 1
	breq	SOUG1		; .. Piepser bleibt aus 
	ldi	R18,$40		; .. sonst Piepser aktivieren
SOUG1:	out	TCCR1A,R18
	sbi	DDRB,2		; NF Degate aktivieren	
	lpm			; Vorschau auf nchstes Byte
	tst	R0		; Wenn Wert = $0
	brne	SOUG2
	clr	ZH		; .. Fertig, SOUPNT MSB auf 0 
SOUG2:	sts	SOUPNT,ZL	; Sound-Pointer retten		
	sts	SOUPNT+1,ZH
SOUG9:	ret



; *******************************************************************************************
; Messspannung UMESSP in Bargraph UMESS(0..7) wandeln 
;
; Anzeige hat 8*4 = 32 Bars, Angezeigt wird UMESSP/4, also
; nur der Berreich 0..127 (Akustisches S-Meter geht bis 255)

CONVUM:	lds	R17,UMESSP	; Spitzenwert Messspannung in R17 bilden
	lds	R16,UMESSP+1
	cp	R17,R16
	brcc	CUM01
	mov	R17,R16			
CUM01:	lds	R16,UMESSP+2
	cp	R17,R16
	brcc	CUM02
	mov	R17,R16			
CUM02:	lds	R16,UMESSP+3
	cp	R17,R16
	brcc	CUM09
	mov	R17,R16			
CUM09:	lds	R16,UMESSP+2	; Spitzenwert-Buffer rechts schieben
	sts	UMESSP+3,R16
	lds	R16,UMESSP+1
	sts	UMESSP+2,R16
	lds	R16,UMESSP
	sts	UMESSP+1,R16
	stsi	UMESSP,0					
	;
	lsr	R17		; 0..127 fr Anzeige auf 0..31 skalieren
	lsr	R17
	ldi	R16,8		; Stellenzhler
	ldi	XH,0		; Pointer auf Bargraph
	ldi	XL,UMESS
	dec	R17		; Um 1 verringern auf -1 .. 30
	;
CUM1:	ldi	R19,$20		; Blank ist Bargraph-Wert 0
	tst	R17		; Wenn Anzeigewert < 0
	brmi	CUM9		;   .. diese Stelle Blank
	;
	ldi	R19,$85		; Bargraphwert auf 4 voreinstellen
	cpi	R17,$04		; Wenn Anzeigewert < 4
	brcc	CUM9
	;
	mov	R19,R17		; .. Bargraphwert ist 2 LSb von Anzeigewert
	andi	R19,$03
	ldi	R18,$82		; .. + $82
	add	R19,R18
	;
CUM9:	st	X+,R19		; Bargraphwert speichern
	ldi	R18,4		; Anzeigewert um 4 verringern
	sub	R17,R18
	dec	R16		; Loopcount, 8 Passes
	brne	CUM1
	;
	ret



; *******************************************************************************************	
; Abschwchercode in Anzeige Dmpfung/Entfernung umrechnen

CONVAB:	lds	R16,ABSBIN	; Abschwcher Code holen
	mov 	R17,R16		; .. und mit 5 malnehmen
	lsl	R17
	lsl	R17
	add	R16,R17
	;	
	ldi	XH,0		; In BCD wandeln fr Abschwcheranzeige
	ldi	XL,ABSCHW
	rcall	B3BCD

; ++ Entfernungsanzeige

	lds	R16,ABSBIN	; Abschwcher Code holen
	lds	R17,PFOXBN	; Korrekturfaktor Sendeleistung holen
	sub	R16,R17
	ldi	R17,7		; Basiskorrekturfaktor, +/-1 verringert/erhht
	add	R16,R17		;   geschtzte Entfernung um Faktor 1,8 (5 dB)
	brpl	CUR2		; Wenn Ergebnis negativ
	ldi	R16,0		; .. auf 0 setzen
CUR2:	cpi	R16,21		; Wenn Ergebnis > 20
	brcs	CUR3
	ldi	R16,20		; .. auf 20 setzen
	;
CUR3:	lds	R17,ABSCHW+1	; Default: Abschwcher-dB-Wert Anzeigen
	lds	R18,ABSCHW+2
	ldi	R19,$80		;   dB Symbol
	;
CUR44:	cpi	R16,4		; 1,5 km
	brne	CUR45
	ldi	R17,1
	ldi	R18,'k'
	ldi	R19,5	
CUR45:	cpi	R16,5		; 1 km
	brne	CUR46
	ldi	R17,1
	ldi	R18,'k'
	ldi	R19,'m'		
CUR46:	cpi	R16,6		; 700 m
	brne	CUR47
	ldi	R17,7
	clr	R18
	clr	R19
CUR47:	cpi	R16,7		; 500 m
	brne	CUR48
	ldi	R17,5
	clr	R18
	clr	R19
CUR48:	cpi	R16,8		; 300 m
	brne	CUR49
	ldi	R17,3
	clr	R18
	clr	R19
CUR49:	cpi	R16,9		; 200 m
	brne	CUR410
	ldi	R17,2
	clr	R18
	clr	R19
CUR410:	cpi	R16,10		; 150 m
	brne	CUR411
	ldi	R17,1
	ldi	R18,5
	clr	R19
CUR411:	cpi	R16,11		; 100 m
	brne	CUR412
	ldi	R17,1
	clr	R18
	clr	R19
CUR412:	cpi	R16,12		; 50 m	
	brne	CUR413		
	ldi	R17,5
	clr	R18
	ldi	R19,'m'		
CUR413:	cpi	R16,13		; 30 m
	brne	CUR414
	ldi	R17,3
	clr	R18
	ldi	R19,'m'		 
CUR414:	cpi	R16,14		; 20 m
	brne	CUR415
	ldi	R17,2
	clr	R18
	ldi	R19,'m'		 
CUR415:	cpi	R16,15		; 10 m
	brne	CUR416
	ldi	R17,1
	clr	R18
	ldi	R19,'m'		 
CUR416:	cpi	R16,16		; 5 m	
	brne	CUR417		
	clr	R17
	ldi	R18,5
	ldi	R19,'m'		 
CUR417:	cpi	R16,17		; 3 m
	brne	CUR418
	clr	R17
	ldi	R18,3
	ldi	R19,'m'		 
CUR418:	cpi	R16,18		; 2 m
	brne	CUR419
	clr	R17
	ldi	R18,2
	ldi	R19,'m'		 
CUR419:	cpi	R16,19		; 1 m	
	brne	CUR420		
	clr	R17
	ldi	R18,1
	ldi	R19,'m'		 
CUR420:	cpi	R16,20		; < 1 m	
	brne	CUR499		
	ldi	R17,'<'
	ldi	R18,1
	ldi	R19,'m'		 
	;
CUR499:	sts	DIST+0,R17	; Entfernungsanzeige speichern	
	sts	DIST+1,R18
	sts	DIST+2,R19	

; Abschwcher-Spannung aus Tabelle holen, x5dB-Werte interpolieren

	lds	R16,ABSBIN	; Abschwcher-Code
	mov	R17,R16		; .. brauchen wir noch
	lsr	R16		; ..geteilt durch 2	
	ldi	XL,low(ABSTAB)	; ist Pointer in Tabelle
	ldi	XH,high(ABSTAB)
	add	XL,R16
	ld	R18,X+		; Analogwert holen
	;
	sbrs	R17,0		; Wenn Code ungerade
	rjmp	CUR52
	cpi	R17,13		; .. und nicht 65 dB
	breq	CUR51	
	ld	R17,X		; .. nchsten Tabellenwert auch noch holen
	add	R18,R17		; .. und Mittelwert bilden
	ror	R18
	rjmp	CUR52
CUR51:	lds	R18,ABSTAB+2	; Sonderfall 65dB: Kein gltiger 60dB-Wert
	lds	R17,ABSTAB+3	; .. stattdessen 30db- und 20 dB-Werte holen
	sub	R17,R18		; A65 = A70 - (A30-A20)/2
	ror	R17
	lds	R18,ABSTAB+7	  	
	sub	R18,R17
	;
CUR52:	out	OCR2,R18	; Analogwert an PWM bergeben

; Bei Abschwchung ab 65 dB Vorstufe ausschalten, sonst an

	lds	R16,ABSBIN	; Abschwcher-Code
	cpi	R16,13		;   >= 65 dB?
	brcc	CUR6
	sbi	DDRC,0		; Nein, Vorstufe Ein
	rjmp	CUR9 
CUR6:	cbi	DDRC,0		; Ja, Vorstufe Aus	
	;
CUR9:	ret



; *******************************************************************************************
; I2C-Treiber
;
; HW-Interface: SDA auf Pin PC5, SCL auf Pin PC4
; Leitungen werden fuer Low aktiv runtergezogen, fuer High 
; freigegeben und gehen ueber externen Pull-Up hoch
; Return-Code fuer alle Ops in R0: 0 = OK, 1 = Missing Ack
;
; ++++ Send Address $C4, Subaddress $00, 3 Databytes in R16, R17, R18 
;      and 1 Databyte $00 to I2C (zugeschnitten auf TSA6057)

OUTI2C:	PUSH	R16
	LDI	R16,$C4		; Chip Address
	RCALL	I2STRT		; Start Sequence
	RCALL	I2SEND		; Send Address
	LDI	R16,$00		; Byte Subaddress
	RCALL	I2SEND		; Send Subaddress
	POP	R16		; Get Data Byte 1
	PUSH	R16
        RCALL	I2SEND		; Send data Byte 1
	MOV	R16,R17
        RCALL	I2SEND		; Send data Byte 2
	MOV	R16,R18
        RCALL	I2SEND		; Send data Byte 3
	LDI	R16,$00
        RCALL	I2SEND		; Send data Byte 4 = $00
	RCALL	I2STOP		; Stop Sequence
	POP	R16
	RET



; ---- Wait > 5 usec after any transition - siehe Bus Spec

I2WAIT:	PUSH 	R16
	LDI	R16,7	; 14 fuer 8 Mhz; 7 fuer 4 MHz Clock
I2W1:	DEC	R16	; 3 Cycle inner Loop	
	BRNE	I2W1	
	POP	R16
	RET

; ++++ Send Start Sequence on I2C

I2STRT:	SDA_LO
	SCL_LO
	RET

; ++++ Send Stop Sequence on I2C

I2STOP:	SDA_LO
	SCL_HI
	SDA_HI
	RET

; ++++ Send Byte in R16 and wait for Ack

I2SEND:	PUSH	R16
	PUSH 	R20
	LDI	R20,8	; Loopcounter bis 8
I2SE1:	TST	R16	; Get MSb to N-Flag
	BRPL	I2SE2	; Put MSb on SDA
	SDA_HI
	RJMP	I2SE3
I2SE2:	SDA_LO
I2SE3:	SCL_HI		; toggle Clock 
	SCL_LO
	LSL	R16	; Shift next bit to MSb
	DEC	R20	; Loopcount
	BRNE	I2SE1
	;
	SDA_HI		; SDA freigeben fuer Ack
	SCL_HI		; Ack anfordern
	CLR	R0	; Error Flag loeschen
I2SE4:	SBIC	PINC,5	; Falls SDA nicht Low ..
	INC	R0	;   .. Error Flag setzen
	;
	SCL_LO		; Ack-Sequenz abschliessen
	;	
	POP	R20
	POP	R16
	RET



; *******************************************************************************************
; Obere Frequenzgrenze umschalten

UDCHGF:	sbrs	R17,4		; Nach Drehdrcker Click
	rjmp	UDCHG0
	lds	R18,FBER68
	com	R18		; Bereichsgrenze 146/148 toggeln
	andi	R18,1		; 0/1 Begrenzung
	sts	FBER68,R18
UDCHG0:	ret



; *******************************************************************************************
; EEPROM nach Drehdrcker-Klick speichern

UDEEWR:	sbrs	R17,4		; Drehdrcker Click aufgetreten?
	rjmp	UDEEW0		; nein...
	rcall	SAVCAL 		; ja, Abgleich-Parameter in EEPROM retten
	flash	STRSAV,10	; EEPROM-Anzeige ausgeben
	sound	SOUEW		; EEPROM Schreiben ausgeben
UDEEW0:	ret



; *******************************************************************************************
; Initialize Steuer-Parameter and speichere sie im EEPROM

UDEENE:	sbrs	R17,4		; nach Drehdrcker Click
	rjmp	UDEEN0		
	rcall	EEPNEW		; EEPROM initialisieren
	flash	STRSAV,10	; Message anzeigen
	sound	SOUEI		; EEPROM Initialisierung ausgeben
UDEEN0:	ret



; *******************************************************************************************
; Initialize Steuer-Parameter and speichere sie im EEPROM

EEPNEW:

; EEPROM: $2000

	stsi	EEPCLR,$A8	; EEPROM valid
	stsi	FRQ1,$E0	; Frequenz 1 144,500
	stsi	FRQ1+1,$01
	stsi	FRQ2,$30	; Frequenz 2 144,600
	stsi	FRQ2+1,$02
	stsi	FRQ3,$80	; Frequenz 3 144,700
	stsi	FRQ3+1,$02
	stsi	FRQ4,$44	; Frequenz 4 144,625
	stsi	FRQ4+1,$02
	stsi	FRQ5,$6c	; Frequenz 5 144,675
	stsi	FRQ5+1,$02
	stsi	FRQ6,$d0	; Frequenz 6 144,800
	stsi	FRQ6+1,$02
	stsi	FRQX,1		; Frequenz 1 aktiv
	stsi	NFOX,0 		; Zahl Timer = 1
	stsi	NFOX+1,1	

; EEPROM: $2010

	stsi	TFOXS,6		; Zeit Fchse = 60 sec
	stsi	TFOXS+1,0
	stsi	TFOXMS,0
	stsi	TFOXMS+1,0
	stsi	PFOX1,12
	stsi	PFOX2,12
	stsi	PFOX3,12
	stsi	PFOX4,8
	stsi	PFOX5,8
	stsi	PFOX6,6
	stsi	PFOXBN,12	; Sendeleistung 1 W bei Frequenz 2
	stsi	NFREQ,6		; 6 Frequenzen maximal
	stsi	TALARM,2	; Alarmzeit 20s
	stsi	TALARM+1,0
	stsi	ACSMLV,1	; Schwelle ACSM auf 1x (1/8)
	stsi	ABSTAB+0,9	; Abschwchertabelle laden

; EEPROM: $2020

	stsi	ABSTAB+1,33
	stsi	ABSTAB+2,62 
	stsi	ABSTAB+3,75
	stsi	ABSTAB+4,115
	stsi	ABSTAB+5,122
	stsi	ABSTAB+6,131
	stsi	ABSTAB+7,104	; <- Ab 65dB Vorstufe aus (etwa - 40 dB)
	stsi	ABSTAB+8,120
	stsi	ABSTAB+9,127
	stsi	ABSTAB+10,141
	stsi	ABSTAB+11,176
	stsi	ABSTAB+12,236
	stsi	FFINE,66	; Frequenzkorrektur 64 = +/-0 
	stsi	UBFINE,125      ; Batterieanzeigekorrektur Mittelwert 
	stsi	FBER68,0	; Frequenzbereich 144..146 MHz	
	stsi	UBWBIN,69	; Batteriewarnschwelle 6,9 Volt

; *******************************************************************************************	
; Gesamtes EEPROM von EEPCLR bis EEPEND-1 schreiben
	
SAVEEP:	STSI	FRQEEP,0	; FRQEEP Flag lschen	
	LDI	YL,LOW(EEPCLR)	; Pointer auf Variablen
	CLR	YH
	LDI	R20,0		; Bytecounter und EPROM Low Adresse
	OUT	EEARH,YH	; High Adresse ist 0
SAVEE1:	LD	R16,Y+		; 1 Variable holen
	rcall	WRBEE		; -> Byte ins EEPROM schreiben
	INC	R20
	CPI	R20,EEPEND-EEPCLR ; Gesamter Bereich geschrieben?
	BRNE	SAVEE1
	RET



; *******************************************************************************************
; Eingestellte Frequenzen von EEP0 bis EEP1-1 ins EEPROM speichern
	
SAVFRQ:	STSI	FRQEEP,0	; FRQEEP Flag lschen	
	LDI	YL,LOW(EEP0)	; Pointer auf Variablen
	CLR	YH
	LDI	R20,EEP0-EEPCLR	; Bytecounter und EPROM Low Adresse
	OUT	EEARH,YH	; High Adresse ist 0
SAVFR1:	LD	R16,Y+		; 1 Variable holen
	rcall	WRBEE		; -> Byte ins EEPROM schreiben
	INC	R20
	CPI	R20,EEP1-EEPCLR ; Gesamter Bereich geschrieben?
	BRNE	SAVFR1
	RET



; *******************************************************************************************
; Eingestellte HW-SetUp-Parameter von EEP1 bis EEP2-1 ins EEPROM speichern
	
SAVSU:	STSI	SUEEP,0		; SUEEP Flag lschen	
	LDI	YL,LOW(EEP1)	; Pointer auf Variablen
	CLR	YH
	LDI	R20,EEP1-EEPCLR ; Bytecounter und EEPROM Low Adresse
	OUT	EEARH,YH	; High Adresse ist 0
SAVSU1:	LD	R16,Y+		; 1 Variable holen
	rcall	WRBEE		; -> Byte ins EEPROM schreiben
	INC	R20
	CPI	R20,EEP2-EEPCLR ; Gesamter Bereich geschrieben?
	BRNE	SAVSU1
	RET



; *******************************************************************************************
; Abgleichwerte von EEP2 bis EEPEND-1 ins EEPROM speichern
	
SAVCAL:	LDI	YL,LOW(EEP2)	; Pointer auf Variablen
	CLR	YH
	LDI	R20,EEP2-EEPCLR ; Bytecounter und EEPROM Low Adresse
	OUT	EEARH,YH	; High Adresse ist 0
SAVCA1:	LD	R16,Y+		; 1 Variable holen
	rcall	WRBEE		; -> Byte ins EEPROM schreiben
	INC	R20
	CPI	R20,EEPEND-EEPCLR ; Gesamter Bereich geschrieben?
	BRNE	SAVCA1
	RET



; *******************************************************************************************
; Frequenzindex ins EEPROM speichern
	
SAVFIX:	ldi	R20,FRQX-EEPCLR	; EEPROM Low Adresse fr FRQX
	clr	YH
	out	EEARH,YH	; High Adresse ist 0
	lds	R16,FRQX	; FRQX-Variable holen
	rcall	WRBEE
	stsi	EEWRAK,0	; Schreiboperation nicht merken
	ret



; *******************************************************************************************
; Ein Byte in r16 nach EEPROM-Adresse in r20 schreiben:

WRBEE:	push	r16
	push	r19
	mov	r19,r16		; zu schreibendes Byte retten
	rcall	RDBEE		; Byte an aktueller EEPROM-Adresse nach r16 lesen
	cp	r19,r16		; Bytes identisch?
	breq	WRBEE1		; ja, keine Schreiboperation ntig!
WRBEE0:	sbic	EECR,EEWE	; sicherheitshalber auf
	rjmp	WRBEE0		; ...Schreib-Ende warten...
	clr	r16
	out	EEARH,r16	; EEPROM-Adresse high
	out	EEARL,r20	; EEPROM-Adresse low
	out	EEDR,r19	; -> Dieses Byte schreiben
	cli			; *** Nicht unterbrechen!!!
	sbi	EECR,EEMWE	; *** Master Write Enable setzen
	sbi	EECR,EEWE	; *** Write Strobe setzen
	sei
	stsi	EEWRAK,1	; Schreiboperation merken
WRBEE1:	pop	r19
	pop	r16
	ret



; *******************************************************************************************
; Ein Byte nach r16 aus EEPROM-Adresse in r20 lesen:

RDBEE:	sbic	EECR,EEWE	; sicherheitshalber auf
	rjmp	RDBEE		; ...Schreib-Ende warten...
	clr	r16
	out	EEARH,r16	; EEPROM-Adresse high
	out	EEARL,r20	; EEPROM-Adresse low
	sbi	EECR,EERE	; EEPROM Leseoperation ausfhren
	in	r16,EEDR	; -> Daten lesen
	ret



; *******************************************************************************************
; Alle Parameter aus dem EEPROM ins RAM holen (max. 256 Bytes!)

GETEEP:	ldi	YL,low(EEPCLR)	; Pointer auf Variablen
	ldi	YH,high(EEPCLR)
	ldi	R20,$00		; Bytecounter und EEPROM Low Adresse
	out	EEARH,R20	; High Adresse ist 0
GET1:	rcall	rdbee		; -> EEPROM-Byte auslesen
	st	Y+,R16		; Byte bzw low nibble speichern
	inc	R20		; Adresse erhhen
	cpi	R20,EEPEND-EEPCLR ; Alle Bytes gelesen?
	brne	GET1
	ret



; *******************************************************************************************
; Subroutine to Copy String to LCD Data Field
;
; String pointed to by Z 
; Variables are inserted according to second 16 Bytes in Data String
; Also handles leading zero suppression

LCDSTR:	PUSH	R0
	PUSH	R16
	PUSH	R17
	PUSH	XL
	PUSH	XH
	PUSH	YL
	PUSH	YH

;++++ Make Y pointer to LCD Data Field

	LDI	YH,HIGH(LCDDAT)
	LDI	YL,LOW(LCDDAT)

;++++ Copy Data String

LCDST1:	LPM			; Get one Byte to R0
	ADIW	ZL,1		; Increment Z
	ST	Y+,R0		; Store Byte
	CPI	YL,LOW(LCDDAT)+16 ; Repeat 16 times
	BRNE	LCDST1	
	;
	LDI	YH,HIGH(LCDDAT)
	LDI	YL,LOW(LCDDAT)

;++++ Insert Variable String

LCDST2:	LPM			; Get one Byte to R0
	ADIW	ZL,1		; Increment Z
	MOV	R16,R0		; Use High Register for Immediate OpCodes
	CPI	YL,LOW(LCDDAT)	; Wenn erstes Byte
	BRNE	LCDS21
	TST	R16		; .. und Inhalt = 0
	BRNE	LCDS21
	RJMP	LCDSTA		; dann keine Variablen = Fertig
LCDS21:	CPI	R16,0		; 0 is next Digit
	BREQ	LCDST5
LCDST3:	MOV	R16,R0		; If not 0: <$10 is NOP
	ANDI	R16,$F0
	BREQ	LCDST9
	MOV	XL,R0
	LDI	XH,0	
LCDST5:	LD	R16,X+		; Get Variable
	CPI	R16,10		; Wenn Im Bereich 0..9
	BRCC	LCDS51		; 
	ORI	R16,'0'		; Convert 0..9 to ASCII
LCDS51:	CPI	R16,'0'		; Handle leading zero
	BRNE	LCDS52
	LD	R17,Y		; 
	CPI	R17,':'
	BRNE	LCDS52
	LDI	R16,' '		; Replace leading zero by Space
LCDS52:	CPI	R16,$80		; Codes im Bereich $80-$87 (Sonderzeichen)
	BRCS	LCDST6
	CPI	R16,$88
	BRCC	LCDST6
	ANDI	R16,$07		; .. nach 0..7 umsetzen
LCDST6:	ST	Y,R16		; Insert character
LCDST9:	INC	YL		; Increment Write Pointer
	CPI	YL,LOW(LCDDAT)+16 ; Repeat 16 times
	BRNE	LCDST2	
LCDSTA:	POP	YH
	POP	YL
	POP	XH
	POP	XL
	POP	R17
	POP	R16
	POP	R0
	RET



; *******************************************************************************************
; LCD-Initialisierung ber die 4-Bit Schnittstelle

INILCD: push	R25
	ldi	R25,20		; Wait 20 msec
	rcall	DELXMS
	ldi	R25,$30		; Initialize LCD 
	rcall	LC1CMD
	ldi	R25,5		; Wait 5 msec
	rcall	DELXMS
	ldi	R25,$30         ; Initialize LCD 
	rcall	LC1CMD
	ldi	R25,5		; Wait 5 msec
	rcall	DELXMS
	ldi	R25,$30		; Initialize LCD
	rcall	LC1CMD
	ldi	R25,16		; Wait Another 16 msec
	rcall	DELXMS
	ldi	R25,$20		; Auf 4 bit Betrieb schalten
	rcall	LC1CMD
	ldi	R25,$28		; System Set: 2zeilig, 5*7 Matrix,4 bit Betrieb
	rcall	LC2CMD
	ldi	R25,$06		; Cursor Mode: laeuft nach rechts
	rcall	LC2CMD
	ldi	R25,$0C		; Display on, Cursor Off
	rcall	LC2CMD
	ldi	R25,$80		; DDRAM-Adress auf 0
	rcall	LC2CMD
	ldi	R25,$01		; Clear Display, Cursor Home
	rcall	LC2CMD
	ldi	R25,2		; Wait 2 msec
	rcall	DELXMS

; Charakter-Generator mit dB-Symbol laden:

	ldi	R25,$40		; Load Character Generator Position 0
	rcall	LC2CMD
	ldi	R25,0b00000110	; .. with compressed dB-Symbol
	rcall	LC2DAT
	ldi	R25,0b00000101
	rcall	LC2DAT
	ldi	R25,0b00000101
	rcall	LC2DAT
	ldi	R25,0b00001110
	rcall	LC2DAT
	ldi	R25,0b00010101
	rcall	LC2DAT
	ldi	R25,0b00010101
	rcall	LC2DAT
	ldi	R25,0b00001110
	rcall	LC2DAT
	ldi	R25,$00	
	rcall	LC2DAT

; Charakter-Generator mit up/dowm Symbol laden

	ldi	R25,$48		; Load Character Generator Position 1
	rcall	LC2CMD
	ldi	R25,0b00000010	; .. with Up + Down Arrow
	rcall	LC2DAT
	ldi	R25,0b00000101
	rcall	LC2DAT
	ldi	R25,0b00000000
	rcall	LCREP3		; 3x mit gleichen Daten wiederholen
	ldi	R25,0b00000101
	rcall	LC2DAT
	ldi	R25,0b00000010
	rcall	LC2DAT
	ldi	R25,$00	
	rcall	LC2DAT

; Charakter-Generator mit | fr S-Meter laden:

	ldi	R25,$50		; Load Character Generator Position 2
	rcall	LC2CMD
	ldi	R25,0b00010000	; .. with |
	rcall	LCREP8		; 8x mit gleichen Daten wiederholen

; Charakter-Generator mit || fr S-Meter laden:

	ldi	R25,$58		; Load Character Generator Position 3
	rcall	LC2CMD
	ldi	R25,0b00011000	; .. with ||
	rcall	LCREP8		; 8x mit gleichen Daten wiederholen


; Charakter-Generator mit ||. fr S-Meter (mit Skala) laden:

	ldi	R25,$60		; Load Character Generator Position 4
	rcall	LC2CMD
	ldi	R25,0b00011000	
	rcall	LC2DAT
	ldi	R25,0b00011010	; .. with || ; (Skala)
	rcall	LCREP6		; 6x mit gleichen Daten wiederholen
	ldi	R25,0b00011000
	rcall	LC2DAT

; Charakter-Generator mit ||.. fr S-Meter (mit Skala) laden:

	ldi	R25,$68		; Load Character Generator Position 5
	rcall	LC2CMD
	ldi	R25,0b00011000	
	rcall	LC2DAT
	ldi	R25,0b00011011	; .. with || ;; (Skala)
	rcall	LCREP6		; 6x mit gleichen Daten wiederholen
	ldi	R25,0b00011000
	rcall	LC2DAT
;
	pop	R25
	ret



; *******************************************************************************************
; Anfang/Ende der Charakter-Definition fr Zeichen $87

DEFCHA:	ldi	r25,$78		; Load Character Generator Position 7
	rcall	LC2CMD

; Zwei Leerzeilen definieren

ENDCHA:	ldi	R25,$00		; Zwei Zeilen
	rcall	LC2DAT		; ...sind
	rcall	LC2DAT		; ...leer
	ret



; *******************************************************************************************
; Rmisch "I" Charakter in Zeichen $87 laden

F1S:	push	r25
	rcall	DEFCHA		; Anfang fr Zeichen $87 schreiben
	ldi	r25,0b00000100
	rcall	LC2DAT
	ldi	r25,0b00000100
	rcall	LC2DAT
	ldi	R25,0b00000100
	rcall	LC2DAT
	ldi	R25,0b00000100
FSEND:	rcall	LC2DAT
	rcall	ENDCHA
	pop	r25		; Restaurieren
	ret



; *******************************************************************************************
; Rmisch "II" Charakter in Zeichen $87 laden

F2S:	push	r25
	rcall	DEFCHA		; Anfang fr Zeichen $87 schreiben
	ldi	r25,0b00001010
	rcall	LC2DAT
	ldi	r25,0b00001010
	rcall	LC2DAT
	ldi	R25,0b00001010
	rcall	LC2DAT
	ldi	R25,0b00001010
	rjmp	FSEND



; *******************************************************************************************
; Rmisch "III" Charakter in Zeichen $87 laden

F3S:	push	r25
	rcall	DEFCHA		; Anfang fr Zeichen $87 schreiben
	ldi	r25,0b00010101
	rcall	LC2DAT
	ldi	r25,0b00010101
	rcall	LC2DAT
	ldi	R25,0b00010101
	rcall	LC2DAT
	ldi	R25,0b00010101
	rjmp	FSEND



; *******************************************************************************************
; Rmisch "IV" Charakter in Zeichen $87 laden

F4S:	push	r25
	rcall	DEFCHA		; Anfang fr Zeichen $87 schreiben
	ldi	r25,0b00010101
	rcall	LC2DAT
	ldi	r25,0b00010101
	rcall	LC2DAT
	ldi	R25,0b00010010
	rcall	LC2DAT
	ldi	R25,0b00010010
	rjmp	FSEND



; *******************************************************************************************
; Rmisch "V" Charakter in Zeichen $87 laden

F5S:	push	r25
	rcall	DEFCHA		; Anfang fr Zeichen $87 schreiben
	ldi	r25,0b00001010
	rcall	LC2DAT
	ldi	r25,0b00001010
	rcall	LC2DAT
	ldi	r25,0b00000100
	rcall	LC2DAT
	ldi	r25,0b00000100
	rjmp	FSEND



; *******************************************************************************************
; Rmisch "VI" Charakter in Zeichen $87 laden

F6S:	push	r25
	rcall	DEFCHA		; Anfang fr Zeichen $87 schreiben
	ldi	r25,0b00010101
	rcall	LC2DAT
	ldi	r25,0b00010101
	rcall	LC2DAT
	ldi	R25,0b00001001
	rcall	LC2DAT
	ldi	R25,0b00001001
	rjmp	FSEND




; *******************************************************************************************
; Copy 16 Bytes from RAM (LCDDAT) to Display 

OUTLCD: push	R16
	push	R25
	push	YL
	push	YH
	;
	ldi	R25,$80		;DDRAM-Adress auf 0
	rcall	LC2CMD
	ldi	YL,LOW(LCDDAT)	;Pointer to Data String
	clr	YH	 
	ldi	R16,8		;Loop-Counter, erste Zeile
OUTLC1:	ld	R25,Y+		;Get one Data Byte
	rcall	LC2DAT		;Write to Display
	dec	R16		;Decrement Loopcounter
	brne	OUTLC1
	;
	ldi	R25,$A8		;DDRAM-Adress auf 40 = Anfang 2te Zeile
	rcall	LC2CMD
	ldi	R16,8		;Loop-Counter, zweite Zeile
OUTLC2:	ld	R25,Y+		;Get one Data Byte
	rcall	LC2DAT		;Write to Display
	dec	R16		;Decrement Loopcounter
	brne	OUTLC2
	;
	pop	YH
	pop	YL
	pop	R25
	pop	R16	 	
	ret



; ********************************************************************************************
; Write Data in R25 (High Nibble) to LCD ( 1 Data Shot)

LC1DAT:	push	R25		; Entry for Data Mode
	swap	R25		
	andi	R25,$0F
	;
	ori	R25,$10
	rjmp 	LC1CM0
	;
LC1CMD:	push	R25		; Entry for Command Mode
	swap	R25		
	andi	R25,$0F
	;
LC1CM0:	ori	R25,$C0		; Pull-Ups fuer Taster
	out	PORTD,R25	; Post Data
	nop
	nop
	nop
	nop
	nop
	sbi	PORTD,5		; Toggle Enable Bit
	nop
	nop
	nop
	nop
	nop
	cbi	PORTD,5
	;
	ldi	R25,70		; Wait 40 usec = 200 cycles
LC1CM1:	dec	R25
	brne	LC1CM1
	;
	pop	R25
	ret



; *******************************************************************************************
; Write Data in R25 as Command to LCD (2 Nibble Shots)

LC2CMD:	push	R25
	rcall	LC1CMD		; Send high nibble
	swap	R25
	rcall	LC1CMD		; and low nibble
	pop	R25
	ret



; *******************************************************************************************
; Multiple Schreiboperation mit gleichen Daten

LCREP8:	rcall	LC2DAT
	rcall	LC2DAT
LCREP6:	rcall	LC2DAT
	rcall	LC2DAT
	rcall	LC2DAT
LCREP3:	rcall	LC2DAT
	rcall	LC2DAT

; Write Data in R25 as Data to LCD (2 Nibble Shots)

LC2DAT:	push	R25
	rcall	LC1DAT		; Send high nibble
	swap	R25
	rcall	LC1DAT		; and low nibble
	pop	R25
	ret



; ********************************************************************************************
; Delay x ms, x in R25 (x * 5 * 256 * 3 Cycle / 4 MHz)

DELXMS:	PUSH	R16
	PUSH	R17
	PUSH	R25
	;
DXMS:	CLR	R16
	LDI	R17,5		
D1MS:	INC	R16		; 3 cycle inner loop
	BRNE	D1MS		; " "     "     " 	
	DEC	R17
	BRNE	D1MS
	DEC	R25
	BRNE	DXMS
	POP	R25
	POP	R17
	POP	R16
	RET



; ********************************************************************************************
; Delay x secs, X in R25

DELXS:	PUSH	R16
	PUSH	R25
	MOV	R16,R25
	LDI	R25,250		; 250 ms Basis Delay
	;
DXS:	RCALL	DELXMS
	RCALL	DELXMS
	RCALL	DELXMS
	RCALL	DELXMS
	DEC	R16
	BRNE	DXS
	;
	POP	R25
	POP	R16
	RET



; ********************************************************************************************
; Drehgeber und Taster entprellen
;
; SWIFLG ist: Bit 0=Up, 1=Down, 2=Up + Pressed, 3=Down + Pressed,
;		  4=Drehdrcker Puls
;		  5=Taster Kurz, 6=Taster Lang 
;
; Ergebnis in SWIFLG wird von Main auf $00 gesetzt.
;
; ++ Debounce Drehgeber Up/Down (alle 1 ms)

DEBNCE:	PUSH	R20		; Used as Temp Register
	;
	LDS	R20,DEBP1 	; Debounce-Counter
	SBIC	PINC,3		
	RJMP	DEB1
	CPI	R20,0		; An unterem Limit?
	BREQ	DEB3		; Do nothing
	DEC	R20		; Counter runterzaehlen	
	STS	DEBP1,R20
	CPI	R20,0		; Jetzt auf Null?
	BRNE	DEB3
	SBIC	PINB,0
	RJMP	DEBINC
	RJMP	DEBDEC
	;
DEB1:	CPI	R20,2		; An oberem Limit (5.5 ms)?
	BREQ	DEB3	
	INC	R20
	STS	DEBP1,R20
	CPI	R20,2		; Jetzt am oberen Limit?
	BRNE	DEB3
	SBIC	PINB,0
	RJMP	DEBDEC
	RJMP	DEBINC
	;
DEBINC: LDI	R20,$1	
	RJMP	DEB2
	;
DEBDEC: LDI	R20,$2
	;
DEB2:	SBIS	PINB,4		; Wenn Drehgeber gedrckt
	LSL	R20		; Flags 2 Stellen links schieben
	SBIS	PINB,4
	LSL	R20
	STS	SWIFLG,R20	; Flags speichern
	LDI	R20,60		; Click-Flag verhindern bei Drck+Dreh
	STS	DEBDD,R20
	;
	; ++ Debounce Drehdrcker (alle 1 ms)
	;
DEB3:	LDS	R20,DEBDD	; Timer holen
	SBIS	PINB,4		; Wenn nicht gedrckt
	RJMP	DEB31
	CPI	R20,50		; .. und Timer war genau am Limit
	BRNE	DEB30
	LDI	R20,$10	  	; .... dann Drcker-Flag setzen
	STS	SWIFLG,R20	; 	 	
	;
DEB30:	CLR	R20		; Timer auf 0 setzen
	RJMP	DEB39
	;
DEB31:	CPI	R20,50		; Gedrckt: Counter schon am Limit?
	BRCC	DEB9		; .. dann nix tun
	INC	R20		; .. sonst Counter hochzaehlen
DEB39:	STS	DEBDD,R20	; .. und retten
	;
DEB9:	POP	R20
	RET
	;
	; **** Debounce Taster (alle 8 ms)
	;
DEBNC2:	PUSH	R20		; Used as Temp Register
	;
DEB4:	LDS	R20,DEBST	; Timer holen
	SBIC	PIND,7		; Wenn Bit (SU) nicht auf 0
	rjmp	DEB41		; .. dann Taster offen
	;
	; Lang drcken handeln
	CPI	R20,125		; Counter schon am Limit (1 sec)?
	BREQ	DEB8		; dann nix tun
	INC	R20		; Counter hochzaehlen
	STS	DEBST,R20	; und retten
	CPI	R20,125		; Jetzt am Limit?
	BRNE	DEB8
	LDS	R20,SWIFLG      ; Dann Flag setzen
	ORI	R20,$40		; 		
	STS	SWIFLG,R20	; 	 	
	rjmp	DEB8
	;
	; Kurz drcken handeln
DEB41:	cpi	R20,10		; War Taster 80 - 1000 ms gedrckt?
	brcs	DEB42 
	cpi	R20,125
	breq	DEB42
	LDS	R20,SWIFLG      ; Dann Flag setzen
	ORI	R20,$20		 		
	STS	SWIFLG,R20	 	 	
DEB42:	clr	R20
	sts	DEBST,R20	
	;
DEB8:	POP	R20
	RET
